<?
/*
 ************************************************************************
 * File Name   : KCRegisterUI.php
 * Class Name  : KCRegisterUI
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("USERREGENV"))  require("../KUserRegEnv.php");
if(!defined("KCUSERREGUI")) require(USERREG_CLASS . "/KCUserRegUI.php");
define("KCREGISTERUI", true);
class KCRegisterUI extends KCUserRegUI
{
    var $m_CheckData;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCRegisterUI()
    {
        $this->KCUserRegUI();
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function InitializeControl()
    {
        $this->m_CheckData = new KCCheckData;
        $this->ExtraInitializeControl();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetHeaderTemplate("Header.ihtml");
        $this->SetFooterTemplate("Footer.ihtml");
        $this->StartRegisterTemplate();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function StartRegisterTemplate()
    {
        ;
    }


    /* ---------------------------------------------
     * virtual function.
     * Set WebParameter to memeber variable.
     * ---------------------------------------------*/
    function SetWebParameter()
    {
        $this->SetExtraWebParameter();
    }


    /* ---------------------------------------------
     * virtual function.
     * Check invalid Web Paramter
     *       - For Function CommonUI Class
     * ---------------------------------------------*/
    function CheckWebParameter()
    {
        $this->ExtraCheckWebParameter();
        if(!$this->m_CheckData->CheckData())
        {
            $this->m_JSUtil->AlertBack($this->m_CheckData->m_ErrMsg);
        }
    }



    /* --------------------------------------------------
     * virtual function
     * access : protected
     * Set UI value.
     * -------------------------------------------------- */
    function SetUIValue()
    {
        $this->m_Template->set_var("K_JSLIB_PATH", K_JSLIB_PATH);
        $this->SetRegisterUIValue();
    }


    /* --------------------------------------------------
     * access : protected
     * virtual function
     * -------------------------------------------------- */
    function SetRegisterUIValue()
    {

    }
}
?>