<?

/*
 ************************************************************************
 * File Name   : KCBoardDownLoad.php
 * Class Name  : KCBoardDownLoad
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KBOARDENV")) require("../KBoardEnv.php");
if(!defined("KCBOARDUI")) require(KBOARD_CLASS . "/KCBoardUI.php");
if(!defined("KCUPLOAD")) require(KBOARD_CLASS . "/KCUpload.php");

define("KCBOARDDOWNLOAD", true);
class KCBoardDownLoad extends KCBoardUI
{

    var $m_UploadId;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardDownLoad()
    {
        $this->KCBoardUI();
        $this->m_IsLicenseDisplay = false; // License κ   
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_UploadId = $HTTP_GET_VARS["uid"];
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->DownFile();
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function DownFile()
    {

        $Upload = new KCUpload($this->m_BoardTable);
        if($Upload->LoadData($this->m_UploadId))
        {
            $FileName    = $Upload->m_FileName;
            $Dir         = KBOARD_BOARD . "/upload/$this->m_BoardTable";
            $ContentType = $Upload->m_ContentType;
            $SaveFile    = "$Dir/" .$Upload->m_SaveFileName;
            $FileSize    = $Upload->m_FileSize;
            $Upload->IncreaseUpload($this->m_UploadId);
            if(file_exists($SaveFile))
            {
                header("Content-Type: $ContentType\n");
                header("Content-Disposition: filename=\"$FileName\"\n");
                header("Content-Transfer-Encoding: binary\n");
                header("Content-Length: $FileSize\n");
                $fn=fopen($SaveFile, "rb");
                if($fn)
                    fpassthru($fn);
            }
            else
            {
                echo "  ʽϴ.  Ǿų Űϴ. ";
            }
        }
    }
}
?>