#----------------------------
#  Խ  
#----------------------------
create table `[TABLENAME]` (
   Id int(11) not null auto_increment,
   Category int(11) not null default '0',
   Name varchar(20),
   EMail varchar(80),
   Homepage varchar(255),
   Subject varchar(255) not null,
   Contents text,
   Passwd varchar(50) not null,
   Wdate datetime not null default '0000-00-00 00:00:00',
   Ip varchar(20) not null,
   Hit int(11) not null default '0',
   Ref int(11) not null default '0',
   Step int(11) not null default '0',
   ReLevel int(11) not null default '0',
   Pds smallint(2) unsigned not null default '0',
   TopOrder smallint(6) not null default '0',
   ViewHtml char(1) not null default 'T',
   primary key (Id),
   index Name (Name),
   index Contents (Contents(100)),
   index Subject (Subject))
   type=MyISAM;


#----------------------------
#  Upload 
#----------------------------
create table `[TABLENAME]_Upload` (
   Id int(11) not null auto_increment,
   BoardId int(11) not null default '0',
   FileName varchar(50) not null,
   SaveFileName varchar(50) not null,
   ContentType varchar(50) not null,
   FileSize varchar(15) not null,
   DownLoad int(11) not null default '0',
   primary key (Id))
   type=MyISAM;
   
#----------------------------
#  Comment 
#----------------------------
create table `[TABLENAME]_Comment` (
   Idx int(11) not null auto_increment,
   PIdx int(11) not null default '0',
   Writer varchar(20) not null,
   DatComment text not null,
   Passwd varchar(50) not null,
   RegDate datetime not null default '0000-00-00 00:00:00',
   primary key (Idx))
   type=MyISAM;
   
#----------------------------
#  Category 
#----------------------------
create table `[TABLENAME]_Category` (
   Idx int(11) not null auto_increment,   
   categoryName varchar(20) not null,
   categoryOrder smallint(6) not null default '0',
   primary key (Idx))
   type=MyISAM;

#----------------------------
# Category ⺻  
#----------------------------
insert  into `[TABLENAME]_Category` values 
(0, 'Ϲ', 0)