<?
/*
 ************************************************************************
 * File Name   : KCBoardComment.php
 * Class Name  : KCBoardComment
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCBOARDCOMMENT", true);
class KCBoardComment extends KCDataBase
{
    var $m_TableName;
    var $m_Idx;
    var $m_PIdx;
    var $m_Writer;
    var $m_DatComment;
    var $m_Passwd;
    var $m_RegDate;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCBoardComment($TableName)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName . "_Comment";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetDataValue($DataValue)
    {
        $this->m_PIdx       = $DataValue["PIdx"];
        $this->m_Writer     = $DataValue["Writer"];
        $this->m_DatComment = $DataValue["DatComment"];
        $this->m_Passwd     = $DataValue["Passwd"];
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_PIdx       = $DbMan->f("PIdx");
        $this->m_Writer     = $DbMan->f("Writer");
        $this->m_DatComment = $DbMan->f("DatComment");
        $this->m_Passwd     = $DbMan->f("Passwd");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSelectSQL($Idx)
    {
        return "SELECT * FROM `$this->m_TableName` WHERE Idx = '$Idx' ";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO `$this->m_TableName`
                (PIdx,   Writer,  DatComment, 
                 Passwd, RegDate ) 
                 VALUES('$this->m_PIdx',   '$this->m_Writer',  '$this->m_DatComment', 
                        PASSWORD('$this->m_Passwd'), now()) ";        
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetUpdateSQL($Idx)
    {
        return "UPDATE `$this->m_TableName` SET 
                    Writer = '$this->m_Writer',
                    DatComment = '$this->m_DatComment'                    
                    WHERE Idx = '$Idx' ";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetDeleteSQL($Idx)
    {
        return "DELETE FROM `$this->m_TableName` WHERE Idx = '$Idx' ";
    }
    
    
    /* --------------------------------------------------
     * access : 
     * PIdx  true̸ Idx PIdx Ѵ.
     * -------------------------------------------------- */
    function DeleteData($Idx, $PIdx = false)
    {
        if($PIdx)
        {
            $Query = "DELETE FROM `$this->m_TableName` WHERE PIdx = '$Idx' ";            
        }
        else
        {
            $Query = "DELETE FROM `$this->m_TableName` WHERE Idx = '$Idx' ";            
        }            
        return $this->ExecuteQuery($Query);    
    }
    
    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckPasswd($Idx, $Password)
    {
        $Ret = false;
        $Query = "SELECT Idx FROM `$this->m_TableName` WHERE Idx='$Idx' AND Passwd = PASSWORD('$Password') ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $Ret = true;
            }
        }
        return $Ret;
    }    
}
?>