<?
/*
 ************************************************************************
 * File Name   : KCCategory.php
 * Class Name  : KCCategory
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCCATEGORY", true);
class KCCategory extends KCDataBase
{
    var $m_Idx;
    var $m_TableName;
    var $m_CategoryName;
    var $m_CategoryOrder;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCategory($TableName)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName . "_Category";
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function SetDataValue($DataValue)
    {
        $this->m_CategoryName  = $DataValue["categoryName"];
        $this->m_CategoryOrder = $DataValue["categoryOrder"];
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        $CategoryOrder = 0 ;
        $Query = " SELECT count(*) as categoryOrder FROM `$this->m_TableName` ";
        $Result = $this->m_DbMan->query($Query);
        if($Result)
        {
            if($this->m_DbMan->next_record())
            {
                $CategoryOrder = $this->m_DbMan->f("categoryOrder");
            }
        }
                
       return "INSERT INTO `$this->m_TableName`(categoryName, categoryOrder)
                    VALUES('$this->m_CategoryName',  '$CategoryOrder' ) ";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function DeleteData($TableName, $Idx)
    {
        $Ret = false;
        $Query = "SELECT categoryOrder FROM `$this->m_TableName` WHERE Idx = '$Idx' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $CategoryOrder = $this->m_DbMan->f("categoryOrder");
                $Query = "DELETE FROM `$this->m_TableName` WHERE Idx = '$Idx' ";
                if($this->AffectOperate($Query))
                {
                    $Query = "UPDATE `$this->m_TableName` SET categoryOrder = categoryOrder -1
                                WHERE  categoryOrder > $CategoryOrder";
                    if($this->ExecuteQuery($Query))
                    {
                        $Ret = true;
                    }
                }
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpdateData($TableName, $Idx)
    {
        $Ret = false;
        $Query = "SELECT categoryOrder FROM `$this->m_TableName` WHERE Idx = '$Idx' ";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $CurCategoryOrder = $this->m_DbMan->f("categoryOrder");

                // Ǵ  簪 Ŭ 
                if($CurCategoryOrder < $this->m_CategoryOrder)
                {
                    $Query = "UPDATE `$this->m_TableName` SET
                                categoryOrder = categoryOrder - 1
                                WHERE categoryOrder > '$CurCategoryOrder'
                                    AND categoryOrder <= '$this->m_CategoryOrder' ";

                }
                // Ǵ     
                else if($CurCategoryOrder > $this->m_CategoryOrder)
                {
                    $Query = "UPDATE `$this->m_TableName` SET
                                categoryOrder = categoryOrder + 1
                                WHERE categoryOrder  < '$CurCategoryOrder'
                                    AND categoryOrder >= '$this->m_CategoryOrder' ";
                }


                if($this->ExecuteQuery($Query))
                {
                    $Query = "UPDATE `$this->m_TableName` SET
                                categoryName    = '$this->m_CategoryName',
                                categoryOrder = '$this->m_CategoryOrder'
                                WHERE Idx = '$Idx'";
                    if($this->AffectOperate($Query))
                    {
                        $Ret = true;
                    }
                }
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
        return $Ret;
    }
}
?>