<?
/*
 ************************************************************************
 * File Name   : KCUpload.php
 * Class Name  : KCUpload
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE"))
{
    require(K_LIB_PATH . "/KCDataBase.php");
}
define("KCUPLOAD", true);
class KCUpload extends KCDataBase
{
    var $m_Id;
    var $m_BoardId;
    var $m_FileName;
    var $m_SaveFileName;
    var $m_ContentType;
    var $m_FileSize;
    var $m_DownLoad;


    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCUpload($TableName)
    {
        $this->KCDataBase();
        $this->m_TableName = $TableName;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSelectSQL($Id)
    {
        return "SELECT * FROM  `" .$this->m_TableName. "_Upload` WHERE Id = '$Id'";
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Id           = $DbMan->f("Id");
        $this->m_BoardId      = $DbMan->f("BoardId");
        $this->m_FileName     = $DbMan->f("FileName");
        $this->m_SaveFileName = $DbMan->f("SaveFileName");
        $this->m_ContentType  = $DbMan->f("ContentType");
        $this->m_FileSize     = $DbMan->f("FileSize");
        $this->m_DownLoad     = $DbMan->f("DownLoad");
    }


    /* --------------------------------------------------
     * access :
     * override ;
     * -------------------------------------------------- */
    function SetDataValue($BoardId, $FileName, $SaveFileName, $ContentType, $FileSize)
    {
        $this->m_BoardId      = $BoardId;
        $this->m_FileName     = $FileName;
        $this->m_SaveFileName = $SaveFileName;
        $this->m_ContentType  = $ContentType;
        $this->m_FileSize     = $FileSize;
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        return "INSERT INTO `" . $this->m_TableName. "_Upload` (BoardId, FileName, SaveFileName, ContentType, FileSize)
                        VALUES('$this->m_BoardId', '$this->m_FileName', '$this->m_SaveFileName', '$this->m_ContentType', '$this->m_FileSize') ";
    }


    /* --------------------------------------------------
     * access : public
     * $UploadIdx  false̸ 
     * $BoardIdx شϴ  ε Ÿ Ѵ.
     * -------------------------------------------------- */
    function DeleteData($BoardId, $UploadId = false)
    {

        // Ǿ ӵǴ  upload file  
        if($UploadId == false)
        {
            $Query = "SELECT SaveFileName FROM `" . $this->m_TableName. "_Upload` WHERE BoardId ='$BoardId'";

        }
        //Upload ϳϳ  
        else
        {
            $Query = "SELECT SaveFileName FROM `" . $this->m_TableName. "_Upload` WHERE Id ='$UploadId'";
        }

        //   
        if($this->m_DbMan->query($Query))
        {
            while($this->m_DbMan->next_record())
            {
                $DeleteFile = UPLOAD_PATH ."/".$this->m_TableName."/".$this->m_DbMan->f("SaveFileName");
                if(file_exists($DeleteFile))
                {
                    unlink($DeleteFile);
                }
            }
        }

        // Ǿ ӵǴ  upload file  
        if($UploadId == false)
        {
            $Query = "DELETE  FROM `" . $this->m_TableName. "_Upload` WHERE BoardId ='$BoardId'";
        }
        //Upload ϳϳ  
        else
        {
            $Query = "DELETE  FROM `" . $this->m_TableName. "_Upload` WHERE Id ='$UploadId'";
        }
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function IncreaseUpload($Id)
    {
        $Query = "UPDATE `" . $this->m_TableName. "_Upload` SET DownLoad = DownLoad + 1 WHERE Id = '$Id'";
        return $this->ExecuteQuery($Query);
    }
}
?>