<?
/*
 ************************************************************************
 * File Name   : KCCheckBox.php
 * Class Name  : KCCheckBox
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCINPUTBOX"))
{
    include("../KCInputBox.php");
}
define("KCCHECKBOX", true);
class KCCheckBox extends KCInputBox
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCCheckBox($Name = "", $Value = "")
    {
        $this->m_Type = $this->INPUT_TYPE_CHECKBOX;
        $this->KCInputBox($Name, $Value);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function SetChecked($Checked)
    {
        if($Checked)
        {
            $this->m_Selected = "checked";
        }
        else
        {
            $this->m_Selected = "";
        }
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function CheckValue($Stand, $Value)
    {
        if($Stand == $Value)
        {
            $this->SetChecked(true);
        }
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetChecked()
    {
        return $this->m_Selected;
    }
}
?>