<?
/*
 ************************************************************************
 * File Name   : KCFile.php
 * Class Name  : KCFile
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
define("KCFILE", true);
class KCFile extends KCCommonClass
{
    var $m_FilePointer;
    var $m_FileName;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCFile($FileName = false)
    {
        $this->KCCommonClass();
        $this->m_FilePointer = false;
        $this->m_FileName = $FileName;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function OpenEx($Mode)
    {
        return $this->Open($this->m_FileName, $Mode);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function Open($FileName, $Mode)
    {
        $Ret = false;
        $this->m_FileName = $FileName;
        $this->m_FilePointer = fopen($this->m_FileName, $Mode);
        if($this->m_FilePointer)
        {
            $Ret = true;
        }
        else
        {
            $this->m_ErrMsg = "   ";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function Close()
    {
        fclose($this->m_FilePointer);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function Read()
    {
        return fread($this->m_FilePointer, $this->GetFileSize());
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetFileSize()
    {
        return filesize($this->m_FileName);
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function Write($FileContents, $Length)
    {
        return fwrite($this->m_FilePointer,$FileContents, $Length);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function Exist($FileName)
    {
        return file_exists($FileName);
    }

}
?>