<?
/*
 ************************************************************************
 * File Name   : KCPaging.php
 * Class Name  : KCPaging
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");

define("KCPAGING", true);
class KCPaging extends KCDataBase
{
    var $m_Field ;
    var $m_Table ;                           // شϴ table ̸
    var $m_WhereClause ;                     // 
    var $m_PageNum ;                         //  page ȣ
    var $m_TotalRowNum ;                     //  row 
    var $m_TotalPageNum ;                    //   
    var $m_ListPerPage ;                     //   µ Ʈ(row) 
    var $m_PrintPageNum ;                    //   µǴ ϴ  ȣ  
    var $m_GroupNum ;                        //  ǥõǴ  group ȣ group̶ - PrintPageNum ؼ µǴ ȣ 
    var $m_TotalGroupNum ;                   //  group 
    var $m_PageLink;                         //  ȣ   ̵ϰ Ǵ ũ ּ
    var $m_PagingFlag;                       // ¡   
    var $WEBPARAM_PAGE_NUMBER = "pn";
    var $CONST_PAGENUM_TPL    = "|PAGENUM|";
    var $CONST_PRE_TEXT       = "";
    var $CONST_NEXT_TEXT      = "";




    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCPaging()
    {
        $this->KCDataBase();
        $this->m_ListPerPage  = 10;
        $this->m_PrintPageNum = 10;
        $this->m_PagingFlag   = true;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function InitPaging($Table, $WhereClause, $Field = "Id",  $PagingFlag = true)
    {
        global $HTTP_GET_VARS;
        $pageNum= $HTTP_GET_VARS[$this->WEBPARAM_PAGE_NUMBER];

        $this->m_Table        = $Table;
        $this->m_WhereClause  = $WhereClause;
        $this->m_Field        = $Field;
        $this->m_PageNum      = $pageNum;
        $this->m_PagingFlag   = $PagingFlag;
        $this->SetTotalRowNum();
        $this->SetTotalPageNum();
        $this->SetGroupNum();
        $this->SetTotalGroupNum();
        $this->InitializePageLink();
    }


    /* --------------------------------------------------
     * access : protected
     * ش ̺  row  
     * -------------------------------------------------- */
    function SetTotalRowNum()
    {
        $Query = "SELECT count($this->m_Field) AS totalcount FROM $this->m_Table $this->m_WhereClause " ;        
        $Result = $this->m_DbMan->query($Query);
        if($Result)
        {
            if($this->m_DbMan->next_record())
            {
                $this->m_TotalRowNum = $this->m_DbMan->f("totalcount");
            }
        }
        else
        {
            $this->m_TotalRowNum = 0 ;
        }
    }


    /* --------------------------------------------------
     * access : protected
     *   ȣ 
     * $totalListNumber   ҷ ´.
     * -------------------------------------------------- */
    function SetTotalPageNum()
    {
        if($this->m_PagingFlag == true)
        {
            if($this->m_TotalRowNum == 0 )
            {
                $this->m_TotalPageNum = 0 ;
            }
            else
            {
                if( ($this->m_TotalRowNum % $this->m_ListPerPage) == 0)
                    $this->m_TotalPageNum = floor($this->m_TotalRowNum / $this->m_ListPerPage) ;
                else
                    $this->m_TotalPageNum = floor($this->m_TotalRowNum / $this->m_ListPerPage + 1) ;
            }
        }
        else
        {
            $this->m_TotalPageNum = 0;
        }
    }


    /* --------------------------------------------------
     * access :
     *   ȣ 
     * PageNum   µ page  Ѵ.
     * -------------------------------------------------- */
    function SetGroupNum()
    {
        //  ȣ  PageNum   µ page  Ѵ.
        $this->m_GroupNum = floor($this->m_PageNum / $this->m_PrintPageNum) ;
    }


    /* --------------------------------------------------
     * access :
     *  page  µǴ
     * PrintPageNum 
     * 0   ٷ   group  ϰ
     * ׷   1 ش.
     * -------------------------------------------------- */
    function SetTotalGroupNum()
    {
        if( ($this->m_TotalPageNum % $this->m_PrintPageNum) == 0)
        {
            $this->m_TotalGroupNum = floor($this->m_TotalPageNum / $this->m_PrintPageNum) ;
        }
        else
        {
            $this->m_TotalGroupNum = floor($this->m_TotalPageNum / $this->m_PrintPageNum + 1) ;
        }
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function InitializePageLink()
    {
        global $HTTP_SERVER_VARS;
        $RequestUri = $HTTP_SERVER_VARS["REQUEST_URI"];
        // Ǿ ִ Page number Ķ͸ Ѵ.
        $temp = strstr($RequestUri, "$this->WEBPARAM_PAGE_NUMBER=$this->m_PageNum");

        if($temp)
        {
            $RequestUri = str_replace("$this->WEBPARAM_PAGE_NUMBER=$this->m_PageNum", "$this->WEBPARAM_PAGE_NUMBER=$this->CONST_PAGENUM_TPL", $RequestUri);
        }
        else
        {
            //URI ĶͰ ִ ɴ.
            $WebParam = strstr($RequestUri, "?");
            // ٸ ĶͰ   & Ķ͸ Ѵ.
            if(strlen($WebParam) > 1)
            {
                $RequestUri .= "&";
            }
            else
            {
                $RequestUri .= "?";
            }
            $RequestUri .= "$this->WEBPARAM_PAGE_NUMBER=$this->CONST_PAGENUM_TPL";
        }

        // WEBParam Template 
        $this->m_PageLink = $RequestUri;
    }



    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function GetPageNumLink($PageNum, $Text)
    {
        $PageLink = str_replace("$this->CONST_PAGENUM_TPL", "$PageNum", $this->m_PageLink);
        $Ret = "<a href='$PageLink'> $Text </a>\n";
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     *    
     * -------------------------------------------------- */
    function GetPrePageNum()
    {
        //Group  0̸ ũ  ٷ 
        if($this->m_GroupNum ==  0 )
        {
            $print_page_number .= " $this->CONST_PRE_TEXT\n " ;
        }
        //Group  0 ũ ̵  ִ PageNumber Ͽ ũ ־ش.
        else if($this->m_GroupNum > 0 )
        {
            $prePageNum = ($this->m_GroupNum * $this->m_PrintPageNum) - 1 ;
            $print_page_number .= $this->GetPageNumLink($prePageNum, "");
        }
        return $print_page_number ;
    }


    /* --------------------------------------------------
     * access :
     * ߰ PrintPageNum ϱ
     * -------------------------------------------------- */
    function GetMiddlePageNum()
    {
        //  group ̰ L PageNum ̰ų Group ̴.
        for($i = $this->m_GroupNum * $this->m_PrintPageNum ; $i < $this->m_TotalPageNum && $i < (($this->m_GroupNum + 1) * $this->m_PrintPageNum) ; $i ++)
        {
            $pageNumber = $i + 1;
            if($i == $this->m_PageNum)
            {
                $print_page_number .="$pageNumber\n";
            }
            else
            {
                $print_page_number .= $this->GetPageNumLink($i, "$pageNumber");
            }
        }
        return $print_page_number ;
    }


    /* --------------------------------------------------
     * access :
     * ڷ   ϱ
     * -------------------------------------------------- */
    function GetNextPageNum()
    {
        //$source_url = $this->GetFullURL();
        if(count($this->m_HiddenValue) > 0)
        {
             $source_url .= "&";
        }

        //Group  ѼGroup  ϳ  ũ ϰ
        if($this->m_GroupNum >= $this->m_TotalGroupNum - 1)
        {
            $print_page_number .= "\t\t $this->CONST_NEXT_TEXT \n ";
        }

        //׷   ũ ش. 
        else if($this->m_GroupNum < $this->m_TotalGroupNum - 1)
        {
            $nextPageNumber = ($this->m_GroupNum + 1) * $this->m_PrintPageNum ;
            //$print_page_number .= " \t\t<a href='" . $source_url . "pageNumber=$nextPageNumber'> </a>\n";
            $print_page_number .= $this->GetPageNumLink($nextPageNumber, );
        }
        //׷   ƹ ϵ  ʴµ ׳  ϰ 
        return $print_page_number ;
    }


    /* --------------------------------------------------
     * access :
     * ̵  ֱ.
     * -------------------------------------------------- */
    function PrintPageNum()
    {
        // page  0̸ ٷ 
        if($this->m_TotalPageNum == 0 )
        {
            return ;
        }
        $source_URL  = $this->GetPrePageNum($WebParam );    // պκ ϱ
        $source_URL .= "&nbsp;&nbsp;" .$this->GetMiddlePageNum()."&nbsp;&nbsp;"; // ߰ κ
        $source_URL .= $this->GetNextPageNum($WebParam );   //  κ
        return $source_URL ;
    }




    /* --------------------------------------------------
     * access :
     * table ; rowd  ġ 
     * -------------------------------------------------- */
    function GetOffSet()
    {
        return $this->m_ListPerPage * $this->m_PageNum;
    }


    /* --------------------------------------------------
     * access : public
     *
     * -------------------------------------------------- */
    function GetListPerPage()
    {
        return $this->m_ListPerPage;
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetPrintPageNum()
    {
        return $this->m_PrintPageNum;
    }


    /* --------------------------------------------------
     * access :  public
     *
     * -------------------------------------------------- */
    function SetListPerPage($Value)
    {
        $this->m_ListPerPage = $Value ;
    }


    /* --------------------------------------------------
     * access :  public
     *
     * -------------------------------------------------- */
    function SetPrintPageNum($Value)
    {
        $this->m_PrintPageNum = $Value ;
    }


    //-----------------------------------------------------------
    // µ Ʈ ȣ شִ Լ
    //-----------------------------------------------------------
    function GetStartListNum()
    {        
        return $this->m_TotalRowNum - ($this->m_ListPerPage * $this->m_PageNum) ;  //  ȣ
    }
}
?>