<?
/*
 ************************************************************************
 * File Name   : KCAdminUI.php
 * Class Name  : KCAdminUI
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    : 
 * Update Date :
 ************************************************************************
 */


if(!defined("KCJNUEUI"))   require(K_KLOCLASS_PATH . "/KCKLOUI.php");
define("KCADMINUI", true);
class KCAdminUI extends KCKLOUI
{    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCAdminUI()
    {
        $this->KCKLOUI();        
    }    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetAuth()
    {
        $this->m_IsAuth  = $this->m_Auth->IsAuth();
        $this->m_IsAdmin = $this->m_Auth->IsAdmin("adminpage");
    }
        
    
    /* --------------------------------------------------
     * virtual function 
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetUIValue()
    {
        $this->m_Template->set_var(array(
            "K_WEB_ROOT"      => K_WEB_ROOT,
            "KBOARD_WEB_ROOT" => KBOARD_WEB_ROOT,
            "ADMIN_WEB"       => ADMIN_WEB,
            "K_LOGIN_WEB"     => K_LOGIN_WEB
        ));
        $this->SetAdminUIValue();        
    }


    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetHeaderTemplate("Header.ihtml");
        $this->SetFooterTemplate("Footer.ihtml");
        $this->AdminTemplate();                
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function AdminTemplate()
    {
        ;               
    }
    

    /* ---------------------------------------------
     * virtual function.
     * Check invalid Web Paramter 
     *       - For Function CommonUI Class
     * ---------------------------------------------*/
    function CheckWebParameter()
    {

        $this->ExtraCheckWebParameter();
        if(!$this->m_CheckData->CheckData())
        {
            $this->m_JSUtil->AlertBack($this->m_CheckData->m_ErrMsg);
        }    
    }    


    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        if(!$this->IsAdmin())
        {
            $this->GoLoginPage("ڰ ƴմϴ.");
        }        
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetAdminUIValue()
    {
                
    }
    
}
?>