<?
/*
 ************************************************************************
 * File Name   : KCZipcodeSB.php
 * Class Name  : KCZipcodeSB
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCSELECTBOX")) require(K_LIB_PATH . "/KCSelectBox.php");
define("KCZIPCODESB", true);
class KCZipcodeSB extends KCSelectBox
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCZipcodeSB($Name)
    {
        $this->KCSelectBox($Name);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function LoadData($Dong = false)
    {
        if($Dong)
        {
            $Query = "SELECT * FROM zipcode WHERE DONG like '%%$Dong%%' ";
        }
        $this->SetDataBaseItemsSQL($Query);
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function AfterSBBind()
    {
        if($this->m_Items->Count() == 0)
        {
            $mItem = new KCItem;
            $mItem->m_Text  = "ġϴ  ϴ." ;
            $mItem->m_Value = "-1";
            $this->m_Items->AddValue($mItem);
        }

    }


    /* --------------------------------------------------
     * protected
     * Load DataBase data into m_Items from SQL
     * --------------------------------------------------*/
    function SetDataBaseItemsSQL($Query)
    {
        $result = $this->m_DbMan->query($Query);
        if($result)
        {
                 $mItem = new KCItem;
            while($this->m_DbMan->next_record())
            {

                $mItem->m_Text  = "[". $this->m_DbMan->f("ZIPCODE") . "] " . $this->m_DbMan->f("SIDO") ." ". $this->m_DbMan->f("GUGUN") ." ". $this->m_DbMan->f("DONG") ." ". $this->m_DbMan->f("RI");
                if($this->m_DbMan->f("ST_BUNJI") != "")
                     $mItem->m_Text .= " ". $this->m_DbMan->f("ST_BUNJI") ."-". $this->m_DbMan->f("ED_BUNJI") ;
                $mItem->m_Value = $this->m_DbMan->f("ZIPCODE");
                $this->m_Items->AddValue($mItem);
            }
        }
        else
        {
            $this->m_ErrMsg  = $this->m_DbMan->m_ErrMsg;
            $this->m_ErrCode = $this->m_DbMan->m_ErrCode;
        }
    }
}
?>