CREATE TABLE kb_boardmanager (
  TableName varchar(65) NOT NULL default 'BoardHeader.ihtml',
  Description varchar(255) NOT NULL default '',
  UseFlag char(1) NOT NULL default 'T',
  RegDate datetime NOT NULL default '0000-00-00 00:00:00',
  TplDirectory varchar(20) default 'hooni',
  TplHeader varchar(20) NOT NULL default 'BoardHeader.ihtml',
  TplFooter varchar(20) NOT NULL default 'BoardFooter.ihtml',
  TplList varchar(20) NOT NULL default 'BoardList.ihtml',
  TplView varchar(20) NOT NULL default 'BoardView.ihtml',
  TplWrite varchar(20) NOT NULL default 'BoardWrite.ihtml',
  TplSmplList varchar(20) NOT NULL default 'BoardTopList.ihtml',
  ListPerPage smallint(6) NOT NULL default '15',
  BoardTitle varchar(50) default 'KONLO BOARD',
  TitleImage varchar(40) default './images/tit_kboard.gif',
  UseTitleImage char(1) NOT NULL default 'T',
  LimitStep smallint(6) default '-1',
  MaxUpload smallint(1) NOT NULL default '0',
  AuthList varchar(10) default 'nobody',
  AuthView varchar(10) default 'nobody',
  AuthInput varchar(10) default 'nobody',
  UseReplyList char(1) NOT NULL default 'T',
  UseCategory char(1) NOT NULL default 'F',
  PRIMARY KEY  (TableName)
) TYPE=MyISAM;

CREATE TABLE kb_pageadmin (
  Idx int(11) NOT NULL auto_increment,
  PageName varchar(20) NOT NULL default '',
  AdminUserId varchar(20) NOT NULL default '',
  PRIMARY KEY  (Idx)
) TYPE=MyISAM;

CREATE TABLE kb_userinfo (
  ID int(11) NOT NULL auto_increment,
  UserId varchar(20) NOT NULL default '',
  Passwd varchar(20) NOT NULL default '',
  Name varchar(20) NOT NULL default '',
  EMail varchar(50) default NULL,
  Homepage varchar(100) NOT NULL default '',
  RegDate datetime NOT NULL default '0000-00-00 00:00:00',
  UniqueId varchar(33) NOT NULL default '',
  UserLevel char(1) NOT NULL default '0',
  IsAdmin char(1) NOT NULL default 'F',
  PRIMARY KEY  (ID)
) TYPE=MyISAM;

CREATE TABLE kb_usertype (
  UserType smallint(6) NOT NULL default '0',
  UserTypeName varchar(20) NOT NULL default '',
  GroupType smallint(6) NOT NULL default '0',
  UserTypeSelectBox varchar(20) NOT NULL default '',
  PRIMARY KEY  (UserType)
) TYPE=MyISAM;