<?
/*
 ************************************************************************
 * File Name   : KCTopOrderSB.php
 * Class Name  : KCTopOrderSB
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCSELECTBOX"))
{
    require( K_LIB_PATH . "/KCSelectBox.php");
}

define("KCTopOrderSB", true);
class KCTopOrderSB extends KCSelectBox
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCTopOrderSB($Name)
    {
        $this->KCSelectBox($Name);
    }


    /* --------------------------------------------------
     * access : public
     * override
     * -------------------------------------------------- */
    function LoadData($TableName)
    {
        $MaxTopOrder = 0;
        $Query= "SELECT max(TopOrder) as MaxTopOrder FROM `$TableName`";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $MaxTopOrder = $this->m_DbMan->f("MaxTopOrder");
            }
        }

        $Items = array();
        for( $i = 0 ; $i <= $MaxTopOrder + 1 ; $i ++)
        {
            $Items[$i] = $i;
        }
        $this->SetDataBaseItemsArray($Items);
    }
}
?>