<?
/*
 ************************************************************************
 * File Name  : KCKLOUI.php
 * Class Name : KCKLOUI
 * File Type  : class
 * version    : Version. 0.1.0
 * Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 * All Rights Reserved.
 * http://www.geonji.co.kr/~konlo
 * function   :
 ************************************************************************
 */

if(!defined("KCCOMMONUI")) require(K_LIB_PATH .   "/KCCommonUI.php");
if(!defined("KCKAuth")) require(K_KLOCLASS_PATH . "/KCKAuth.php");
define("KCREGISTERUI", true);
class KCKLOUI extends KCCommonUI
{
    var $m_Auth;
    var $m_IsAuth;
    var $m_IsAdmin;
        
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCKLOUI()
    {
        $this->KCCommonUI();
        $this->m_Auth    = new KCKAuth;
        $this->m_IsAuth  = false;
        $this->m_IsAdmin = false;        
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetAuth()
    {
        $this->m_IsAuth  = $this->m_Auth->IsAuth();
    }



    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function StartTemplate()
    {
        // $this->InitializeTemplate("./template");
        // $this->SetHeaderTemplate("Header.ihtml");
        // $this->SetFooterTemplate("Footer.ihtml");
        // $this->HeritageTemplate();
    }
    

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetAdminAuth($PageName = false)
    {
        $this->m_IsAdmin = $this->m_Auth->IsAdmin($PageName);
    }


    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function IsAdmin()
    {
        return $this->m_IsAdmin;
    }
 

    /* --------------------------------------------------
     * access : protected
     *
     * -------------------------------------------------- */
    function IsAuth()
    {
        return $this->m_IsAuth;
    }    
    
    
    /* --------------------------------------------------
     * access : public 
     * ƿ  Ͽ ٽ ƿ 
     * -------------------------------------------------- */
    function GoNextPageAndBack($Url)
    {
        global $REQUEST_URI;
        $Url .= "?nu=" . urlencode($REQUEST_URI);
        $this->GoNextPageEx($Url);
    }    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GoLoginPage($Msg)
    {        
        
        $this->m_JSUtil->Alert($Msg);
        $this->GoNextPageAndBack(K_LOGIN_WEB . "/GLogin.php");
    }
}
?>