<?
/*
 ************************************************************************
 * File Name   : KCUserInfo.php
 * Class Name  : KCUserInfo
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCDATABASE")) require(K_LIB_PATH . "/KCDataBase.php");
define("KCUSERINFO", true);
class KCUserInfo extends KCDataBase
{
    var $m_Id;
    var $m_UserId;
    var $m_Passwd;
    var $m_Name;
    var $m_EMail;
    var $m_Homepage;
    var $m_RegDate;
    var $m_UniqueId;
    var $m_UserLevel;

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCUserInfo()
    {
        $this->KCDataBase();
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function SetDataValue($DataValue)
    {
        $this->m_UserId         = $DataValue["UserId"];
        $this->m_Passwd         = $DataValue["Passwd"];
        $this->m_Name           = $DataValue["Name"];
        $this->m_Homepage       = $DataValue["Homepage"];
        $this->m_EMail          = $DataValue["EMail1"]. "@" . $DataValue["EMail2"];
    }


    /* --------------------------------------------------
     * access : protected
     * override
     * Move data From Database Row to member variable
     * -------------------------------------------------- */
    function LoadMemberValue($DbMan)
    {
        $this->m_Id             = $DbMan->f("ID");
        $this->m_UserId         = $DbMan->f("UserId");
        $this->m_Passwd         = $DbMan->f("Passwd");
        $this->m_Name           = $DbMan->f("Name");
        $this->m_EMail          = $DbMan->f("EMail");
        $this->m_Homepage       = $DbMan->f("Homepage");
        $this->m_RegDate        = $DbMan->f("RegDate");
        $this->m_UniqueId       = $DbMan->f("UniqueId");
        $this->m_UserLevel      = $DbMan->f("UserLevel");
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSelectSQL($UserId)
    {
        return "SELECT * FROM kb_userinfo WHERE UserId = '$UserId' ";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function CheckUserLogin($UserId, $Passwd)
    {
        $Ret = false;
        $Query = "SELECT * FROM kb_userinfo WHERE UserId = '$UserId' AND Passwd = PASSWORD('$Passwd')";
        if($this->m_DbMan->query($Query))
        {
            if($this->m_DbMan->next_record())
            {
                $this->LoadMemberValue($this->m_DbMan);                
                $Ret = true;
            }
        }
        return $Ret;
    }



    /* --------------------------------------------------
     * access : protected
     * override
     * -------------------------------------------------- */
    function GetInsertSQL()
    {
        $this->m_UniqueId = md5(time());
        return "INSERT INTO kb_userinfo(UserId, Passwd, Name,
                EMail,   Homepage,  RegDate,        
                UniqueId )
                VALUES('$this->m_UserId',   PASSWORD('$this->m_Passwd'), '$this->m_Name',
                '$this->m_EMail',          '$this->m_Homepage',           now(),                     
                '$this->m_UniqueId') ";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetUpdateSQL($UserId)
    {
        $Query = "UPDATE kb_userinfo SET
                    EMail          = '$this->m_EMail',
                    Homepage       = '$this->m_Homepage',
                    Name           = '$this->m_Name'
                     ";
        if($this->m_Passwd != "")
        {
            $Query .= ", Passwd = PASSWORD('$this->m_Passwd') ";
        }
        $Query .= " WHERE UserId = '$UserId' ";
        return $Query;
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetDeleteSQL($UserId)
    {
        return "DELETE FROM kb_userinfo WHERE UserId= '$UserId'";
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpdatePasswd($UserId, $Passwd)
    {
        $Query = "UPDATE kb_userinfo SET Passwd = PASSWORD('$Passwd') WHERE UserId = '$UserId'";
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function UpdateUserLevel($UserId, $UserLevel)
    {
        $Query = "UPDATE kb_userinfo SET UserLevel = '$UserLevel' WHERE UserId = '$UserId'";
        return $this->ExecuteQuery($Query);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function IsExistUserId($UserId)
    {
        $Ret = true;
        $Query = "SELECT UserId FROM kb_userinfo WHERE UserId = '$UserId'";
        if($this->m_DbMan->query($Query))
        {
            if(!$this->m_DbMan->next_record())
            {
                $Ret = false;
            }
        }
        return $Ret;
    }
    
    
    /* --------------------------------------------------
     * access : public 
     * ڰ ϴ ˾ƺ. 
     * -------------------------------------------------- */    
    function IsExistAdmin()
    {
        $Ret = true;
        $Query = "SELECT UserId FROM kb_userinfo WHERE IsAdmin = 'T' ";
        if($this->m_DbMan->query($Query))
        {
            if(!$this->m_DbMan->next_record())
            {
                $Ret = false;
            }        
        }
        return $Ret;
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetEMail($Pos)
    {
        return $this->GetSplitValue($this->m_EMail, "@", $Pos);
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GetSplitValue($Value, $Splitter, $Pos)
    {
        $Ret = "";
        $Values = split($Splitter, $Value);
        if(count($Values) >= $Pos)
        {
            $Ret = $Values[$Pos];
        }
        return $Ret;
    }
}
?>