<?
/*
 ************************************************************************
 * File Name   : GLogin.php
 * Class Name  : KCGLogin
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    : 
 * Update Date :
 ************************************************************************
 */


if(!defined("K_LIB_ENV"))     require("../kEnv.php");
if(!defined("KCLOGINUI"))     require(K_KLOCLASS_PATH . "/KCLoginUI.php");
if(!defined("KCUSERTYPESB"))  require(K_KLOCLASS_PATH . "/KCUserTypeSB.php");
define("KCGLOGIN", true);
class KCGLogin extends KCLoginUI
{    
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCGLogin()
    {
        $this->KCLoginUI();
    }
    
    /* --------------------------------------------------
     * access : protected
     * override 
     * -------------------------------------------------- */    
    function StartTemplate()
    {
        $this->InitializeTemplate("./template");
        $this->SetTemplate("GLogin.ihtml");        
        //$this->SetBlock();
    }    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        global $HTTP_GET_VARS;
        $this->m_NextUrl = $HTTP_GET_VARS["nu"];     
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function ExtraCheckWebParameter()
    {
        if($this->IsAuth())
        {
            //$this->m_CheckData->SetCheckValue("-1", "-1", "α Ǿ ֽϴ.");
        }        
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function SetLoginUIValue()
    {
        $this->m_Template->set_var(array(
                    "USERTYPE"   => $this->GetUserType(),
                    "K_WEB_ROOT" => K_WEB_ROOT,
                    "NEXT_URL"   => urlencode($this->m_NextUrl)
        ));
    }
        
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function GetUserType()
    {
        $UserType = new KCUserTypeSB("UserType");       
        $UserType->SetAttribute("style", "width:145;");
        $UserType->LoadData($this->m_Auth->GetUserType());
        return $UserType->SBBind();        
    }    
}

    $GLogin = new KCGLogin;
    $GLogin->PageLoad();
    $GLogin->LoadTemplate();
?>