<?
/*
 ************************************************************************
 * File Name   : Login.php
 * Class Name  : KCLogin
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("K_LIB_ENV"))    require("../kEnv.php");
if(!defined("KCLOGINUI"))    require(K_KLOCLASS_PATH. "/KCLoginUI.php");
if(!defined("KCKAUTH"))      require(K_KLOCLASS_PATH. "/KCKAuth.php");
define("KCLOGIN", true);
class KCLogin extends KCLoginUI
{
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCLogin()
    {
        $this->KCLoginUI();
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetInitData()
    {
        $this->Login();
    }

    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function SetExtraWebParameter()
    {
        global $HTTP_POST_VARS;
        $this->m_NextUrl = $HTTP_POST_VARS["nu"];
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function GoAfterLogin()
    {
        if($this->m_NextUrl != "")
        {
            $this->GoNextPage(urldecode($this->m_NextUrl));
        }
        else
        {
            $this->GoNextPage(K_START_PAGE);
        }                
    }


    /* --------------------------------------------------
     * access :
     *
     * -------------------------------------------------- */
    function Login()
    {
        global $HTTP_POST_VARS;
        if($this->m_Auth->IsAuth())
        {
            $this->m_Auth->Logout();
        }
        if($this->m_Auth->Login($HTTP_POST_VARS["UserId"], $HTTP_POST_VARS["Passwd"]))
        {
            $this->GoAfterLogin();
        }
        else
            $this->m_JSUtil->AlertBack($this->m_Auth->m_ErrMsg);
    }
}
    $Login = new KCLogin;
    $Login->PageLoad();
?>