<?
/*
 ************************************************************************
 * File Name   : KCMail.php
 * Class Name  : KCMail
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require( K_LIB_PATH . "/KCCommonClass.php");
define("KCMAIL", true);
class KCMail extends KCCommonClass
{
    var $m_SendMode ;                   //    ƴϸ       "individual" , "all";
    var $m_SenderData = array();        //   ̸,    ּ, array( "sender" => sender , "email" => email)
    var $m_ReceiverData = array();      // ޴  array("receiver" => receiver, "email" => mail) 迭 
    var $m_Subject ;                    // 

    var $m_XMailer ;                    // XMailer
    var $m_XPriority;                   // ߿䵵
    var $m_ReturnPath ;                 // return  ּ
    var $m_HtmlFlag;                    // html  default true  htmlϰڴ. ׷  false  ϰ html_use    Ѵ.
    var $m_Headers ;                    // Heaeder 


    var $SENDMODE_INDIVIDUAL = "individual";
    var $SENDMODE_ALL        = "all";

    var $XPRIORITY_HIGH      = 2;
    var $XPRIORITY_NORMAL    = 3;
    var $XPRIORITY_LOW       = 4;


    var $XMAILER             = "X-Mailer: PHP\n";
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCMail()
    {
        $this->KCCommonClass();
        $this->m_XPriority = $this->XPRIORITY_NORMAL;
        $this->m_HtmlFlag  = true;
    }


    /* --------------------------------------------------
     * access : public
     *     Ѵ.   
     * ϵ 
     * -------------------------------------------------- */
    function SetSender($sender, $mail)
    {
    	$this->m_SenderData = array(
    	                "sender" => $sender,
    	                "email" => $mail);
    }


    /* --------------------------------------------------
     * access : protected
     *    üũ
     * -------------------------------------------------- */
    function IsSetSender()
    {
        $Ret = false;
        //    
        if(count($this->m_SenderData) > 0)
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     * ޴    Ѵ. ȣ 
     * ޴  ߰
     * -------------------------------------------------- */
    function SetReceiver($Receiver, $Mail)
    {
    	// ּҰ   ޴  ܸ ϰ   ϰ ִٰ
    	//ڿ ٽ  Ϸ 
    	if($Mail != "")
    	{
        	$temp = array(
        	        "receiver" => $Receiver,
        	        "email"    => $Mail
        	        );
        	$count = count($this->m_ReceiverData);
        	$this->m_ReceiverData[$count] = $temp;
        }
    }


    /* --------------------------------------------------
     * access :
     * ޴   ¸ ȭ ؼ ش.
     * -------------------------------------------------- */
    function GetFormatReceiver($ReceiverArray)
    {
    	//޴  ̸    ׳ ϸ 
   		if(empty($ReceiverArray["receiver"]))
   		{
   			$receiver .= $ReceiverArray["email"] ;
   		}
   		//޴    '̸ <  ּ>' · 
   		else
   		{
   			$receiver .= $ReceiverArray["receiver"] . "<" . $ReceiverArray["email"] . ">";
   		}
   		return $receiver ;
    }


    /* --------------------------------------------------
     * access : protected
     * ޴   üũ
     * -------------------------------------------------- */
    function IsSetReceiver()
    {
        $Ret = false;
        //޴    
        if( count($this->m_ReceiverData) > 0)
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     *  ϱ
     * -------------------------------------------------- */
    function SetSubject($Subject)
    {
        $this->m_Subject = $Subject ;
    }


    /* --------------------------------------------------
     * access :
     *   
     * -------------------------------------------------- */
    function GetSubject()
    {
        return $this->ReplaceString($this->m_Subject);
    }


    /* --------------------------------------------------
     * access :
     *  ˻
     * -------------------------------------------------- */
    function IsSetSubject()
    {
        $Ret = false;
        //    
        if(!empty($this->m_Subject))
        {
            $Ret = true;
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     * SetSendmode Ǵ mode 'all' 'individual'
     * -------------------------------------------------- */
    function SetSendMode($Mode)
    {
        switch($Mode)
        {
            case $this->SENDMODE_ALL:
            case $this->SENDMODE_INDIVIDUAL;
                $this->m_SendMode = $Mode;
            break;
            default:
                $this->m_SendMode = $this->SENDMODE_INDIVIDUAL;
                break;
        }
    }


    /* --------------------------------------------------
     * access : protected
     * SetSendmode Ǵ mode 'all' 'individual'
     * -------------------------------------------------- */
    function GetSendMode()
    {
    	return $this->m_SendMode ;
    }


    /* --------------------------------------------------
     * access :
     *    ʱ  ˻մϴ.
     * -------------------------------------------------- */
    function CheckInitValue()
    {
        $Ret = true;
        //   üũ  
        if( !$this->IsSetSender() )
        {
            $Ret = false;
            $this->m_ErrMsg = "   ϴ. ";
        }
        else if( !$this->IsSetReceiver())
        {
            $Ret = false;
            $this->m_ErrMsg = "޴   ϴ. ";
        }

        else if( !$this->IsSetSubject())
        {
            $Ret = false;
            $this->m_ErrMsg = "  ʽϴ. ";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     * ʱȭ ʿ  Ǿ ִ ˻ϰ
     * ⺻  Ѵ.
     * -------------------------------------------------- */
    function Init()
    {
        $Ret = false;
        if($this->CheckInitValue())
        {
            //  ϷǸ   ȣ
            $this->SetHeader();                   // ʱȭ
            $Ret = true;
        }
        return $Ret ;
    }


    /* --------------------------------------------------
     * access :
     * ڰ ϴ sendMail Լ Լ sendMode
     *    ߼ Ǵ  ⸦
     *   ִ.
     * -------------------------------------------------- */
    function SendMail($message)
    {
        $Ret = false;
        //Ÿ ʱȭ Ȯ  ʱȭ
        if($this->Init())
        {
            //  ⸦ Ѵٸ  ڸ ȣϿ ȣ  ϰ
            if($this->m_SendMode == $this->SENDMODE_INDIVIDUAL)
            {
                for($i = 0 ; $i < count($this->m_ReceiverData) ; $i ++)
                {
                	//  ̸     Ѵ.
                    $this->MSend($this->m_GetReceiver($this->m_ReceiverData[$i]), $message);
                }
            }
            //׷     ּҸ Ϲ޾ ٷ  ߼Ѵ.
            else
            {
                if($this->MSend($this->GetReceiver(), $message))
                {
                    $this->m_ErrMsg = count($this->m_ReceiverData)."  ߼۵Ǿϴ.";
                    $Ret = true;
                }
            }
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     * mailԼ ȣϱ
     * -------------------------------------------------- */
    function MSend($Receiver, $Message)
    {
    	return mail($Receiver, $this->m_Subject, $Message, $this->m_Headers);
    }


    /* --------------------------------------------------
     * access : protected
     * Html  
     * -------------------------------------------------- */
    function GetHtmltype()
    {
        $Ret = "";
        if($this->m_HtmlFlag == true)
        {
            $Ret = "Content-Type: text/html; charset=euc-kr \n"; // Mime type
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access : public
     * Html Set
     * -------------------------------------------------- */
    function m_SetHtmlType($Flag)
    {
        $this->m_HtmlFlag = $Flag ;
    }


    /* --------------------------------------------------
     * access :
     *   ϱ
     * -------------------------------------------------- */
    function SetHeader()
    {
    	$this->m_Headers .=  $this->GetFrom();
    	$this->m_Headers .=  $this->GetXSender();
    	$this->m_Headers .=  $this->XMAILER;
    	$this->m_Headers .=  $this->GetXPriority() ;
    	$this->m_Headers .=  $this->GetReturnPath();
    	$this->m_Headers .=  $this->GetHtmlType();
    }


    /* --------------------------------------------------
     * access :
     *    
     * -------------------------------------------------- */
    function GetFrom()
    {
        $Ret = "";
        if(empty($this->m_SenderData["sender"]))
        {
            $Ret ="From: ". $this->m_SenderData["email"]."\n";
        }
        else
        {
            $Ret = "From: ". $this->m_SenderData["sender"] ."<" .$this->m_SenderData["email"] ."> \n";
        }
        return $Ret;
    }


    /* --------------------------------------------------
     * access :
     * X-Sender 
     * -------------------------------------------------- */
    function GetXSender()
    {
        return "X-Sender: <$this->m_SenderEmail>\n";
    }


    /* --------------------------------------------------
     * access :
     * 켱 
     * -------------------------------------------------- */
    function GetXPriority()
    {
        return "X-Priority: $this->m_XPriority\n";
    }


    /* --------------------------------------------------
     * access :
     * Return Path
     * -------------------------------------------------- */
    function GetReturnPath()
    {
        return "Return-Path: <". $this->m_SenderData["email"] .">\n";
    }


    //--------------------------------------------------------------------------------
    // ޴   
    //--------------------------------------------------------------------------------
    function GetReceiver()
    {
    	//ĶͰ       ϰ
    	if( func_num_args() == 0 )
    	{
        	for($i = 0 ; $i < count($this->m_ReceiverData) ; $i ++)
        	{
        		$receiver .= $this->GetFormatReceiver($this->m_ReceiverData[$i]);

        		if($i + 1 < count($this->m_ReceiverData) )
        		{
        			$receiver .= ", ";
        		}
        	}
        }
        //׷   Ѿ Ķʹ receiver mail   ִ 迭 ̹Ƿ   иϰ Ͽ
        //  Ѵ.
        else
        {
        	$receiver = $this->GetFormatReceiver(func_get_arg(0));
        }
    	return $receiver ;
    }
}
?>