<?
/*
 ************************************************************************
 * File Name   : KCPageManager
 * Class Name  : KCPageManager.php
 * File Type   : class
 * version     : Version. 0.2.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    :
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require(K_LIB_PATH . "/KCCommonClass.php");
define("KCPAGEMANAGER", true);
class KCPageManager extends KCCommonClass
{
    var $m_HiddenValue ;                  // hidden value Ǿ 

    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCPageManager()
    {
        $this->KCCommonClass();
    }


    /* --------------------------------------------------
     * access : public
     *  ̵ URL ĶͿ  
     * -------------------------------------------------- */
    function SetHiddenValue($key, $value)
    {
        $this->m_HiddenValue[$key] = $value ;
    }


    /* --------------------------------------------------
     * access : public
     *  ̵ URL ĶͿ  
     * -------------------------------------------------- */
    function GetHiddenValue($key)
    {
        return $this->m_HiddenValue[$key] ;
    }


    /* --------------------------------------------------
     * access : public
     * Hidden      
     * -------------------------------------------------- */
    function GetAllHiddenForm()
    {
        //   迭   ִ ˻
        if( is_array($this->m_HiddenValue))
        {
            $keys   = array_keys($this->m_HiddenValue);
            $values = array_values($this->m_HiddenValue);
        }
        else
        {
            return ;
        }

        for($i = 0 ; $i < count($keys) ; $i ++)
        {
            $hidden_values .= "<input type=hidden name='" . $keys[$i] . "' value='" . $values[$i] ."'>\n" ;
        }
        return $hidden_values ;
    }


    /* --------------------------------------------------
     * access : public
     * Hidden value Ǿ ִ  hidden form 
     * Ѵ. ϴ   ϴ  
     * -------------------------------------------------- */
    function GetHiddenForm()
    {
        //ϴ     
        if( func_num_args() == 0)
        {
            $hidden_values = $this->GetAllHiddenForm();
        }

        //ϴ    ϴ  
        // 迭 key  Ѵ.
        else
        {
            for($i = 0 ; $i < func_num_args() ; $i ++)
            {
                $key = func_get_arg($i);
                $hidden_values .=  "<input type=hidden name='" . $key . "' value='" . $this->m_HiddenValue[$key] ."'>\n" ;
            }
        }
        return $hidden_values ;
    }


    /* --------------------------------------------------
     * access : public
     * Hidden value Ǿ ִ  hidden form 
     * Ѵ. ϴ ʴ     
     * -------------------------------------------------- */
    function GetHiddenSubForm()
    {
        // ϴ   ٷ   hidden form 
        if( func_num_args() == 0)
        {
            $hidden_values = $this->GetAllHiddenForm();
        }

        //⸦ ϴ   
        else
        {
            // Ǿ ִ hidden  ִ  ˻ϰ
            //  (ϳ Ǿ  迭   )
            if(is_array($this->m_HiddenValue))
            {
                //hidden key  value  
                $keys = array_keys($this->m_HiddenValue);
                $values = array_values($this->m_HiddenValue);

                //⸦ ϴ key 
                $sub_keys = func_get_args();

                // var_dump($keys);
                // var_dump($sub_keys);

                //hidden   ŭ loop .
                for($i = 0 ; $i < count($keys) ; $i ++)
                {
                    $find_flag = false; // ⸦ ϴ key ãҴ ˻
                    $current_key = $keys[$i] ; // key 

                    //   key  ⸦ ϴ keys ִ $sub_keysŭ
                    // ׸ find_flag false   ã   ؼ loop Ѵ.
                    for($j = 0 ; $j < count($sub_keys) and $find_flag == false; $j ++)
                    {
                        // ϴ  ã  $find_flag trueŰ  ´.
                        if( $current_key == $sub_keys[$j])
                        {
                                $find_flag = true ;
                        }
                    }

                    //  鼭 current_key ⸦ ϴ key    Ѵ.
                    if($find_flag == false)
                    {
                        $hidden_values .=  "<input type=hidden name='" . $current_key . "' value='" . $this->m_HiddenValue[$current_key] ."'>\n" ;
                    }
                }

            }
            //  Ƿ ٷ  Ѵ.
            else
            {
                    return ;
            }
        }
        return $hidden_values ;
    }


    /* --------------------------------------------------
     * access : public
     * Hidden value Ǿ ִ  Url Ķ 
     * Ѵ. ϴ   ϴ  
     * -------------------------------------------------- */
    function GetHiddenParam()
    {
        // ϴ     
        if( func_num_args() == 0)
        {
            //迭   ׳ 
            if( count($this->m_HiddenValue) == 0 )
            {

            }
            //迭   迭  
            else
            {
                $keys = array_keys($this->m_HiddenValue);
                $values = array_values($this->m_HiddenValue);

                for($i = 0 ; $i < count($keys) ; $i ++)
                {
                    $param .= $keys[$i] ."=" . $values[$i] ;
                    if($i + 1 < count($keys) )
                    {
                        $param .= "&" ;
                    }
                }
            }
        }
        //func_get_arg($i) ;
        //Ư ϴ   ϴ  
        else
        {
            for($i = 0 ; $i < func_num_args() ; $i ++)
            {
                $key = func_get_arg($i);
                $param .= $key . "=" . $this->m_HiddenValue[$key] ;
                if($i + 1 < func_num_args() )
                {
                    $param .= "&";
                }
            }
        }
        return $param ;
    }


    /* --------------------------------------------------
     * access : public
     *  ʴ Ķ  ϱ
     * -------------------------------------------------- */
    function GetHiddenSubParam()
    {

        // ϴ   ٷ   hidden form 
        if( func_num_args() == 0)
        {
            $hidden_values = $this->GetHiddenParam();
        }

        //⸦ ϴ   
        else
        {
            // Ǿ ִ hidden  ִ  ˻ϰ
            //  (ϳ Ǿ  迭   )
            if(is_array($this->m_HiddenValue))
            {
                //hidden key  value  
                $keys = array_keys($this->m_HiddenValue);
                $values = array_values($this->m_HiddenValue);

                //⸦ ϴ key 
                $sub_keys = func_get_args();

                // var_dump($keys);
                // var_dump($sub_keys);

                //hidden   ŭ loop .
                for($i = 0 ; $i < count($keys) ; $i ++)
                {
                    $find_flag = false; // ⸦ ϴ key ãҴ ˻
                    $current_key = $keys[$i] ; // key 

                    //   key  ⸦ ϴ keys ִ $sub_keysŭ
                    // ׸ find_flag false   ã   ؼ loop Ѵ.
                    for($j = 0 ; $j < count($sub_keys) and $find_flag == false; $j ++)
                    {
                        // ϴ  ã  $find_flag trueŰ  ´.
                        if( $current_key == $sub_keys[$j])
                        {
                            $find_flag = true ;
                        }
                    }

                    //  鼭 current_key ⸦ ϴ key    Ѵ.
                    if($find_flag == false)
                    {
                        $hidden_values .=  "$current_key=". $this->m_HiddenValue[$current_key] ;
                        if($i + 1 < count($keys))
                        {
                        	$hidden_values .="&";
                        }
                    }
                }

            }
            //  Ƿ ٷ  Ѵ.
            else
            {
                return ;
            }
        }
        return $hidden_values ;
    }
}

?>