<?
/*
 ************************************************************************
 * File Name   : KCPass.php
 * Class Name  : KCPass
 * File Type   : class
 * version     : Version. 0.1.0
 *              Copyright 2001, 2002, 2003 Na Jong Sung <konlo@geonji.co.kr>
 *              All Rights Reserved.
 *              http://www.geonji.co.kr/~konlo
 * function    : 
 * Update Date :
 ************************************************************************
 */


if(!defined("KCCOMMONCLASS")) require( K_LIB_PATH . "/KCCommonClass.php");
define("KCPASS", true);
class KCPass extends KCCommonClass
{    
    var $m_ObsDirectory;
    var $m_RelDirectory;
    /* --------------------------------------------------
     * access : public
     * ctor.
     * -------------------------------------------------- */
    function KCPass()
    {
        $this->KCCommonClass();
        $this->m_FileList     = array();
        $this->m_ObsDirectory = array();
    }    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function LoadDirectory($Path = ".")
    {
        if ($dir = @opendir($Path)) 
        {
            $this->AddObsDirectory($Path);
            $this->AddRelDirectory("jnue");
            while (($file = readdir($dir)) !== false) 
            {
                if(is_dir($Path . "/$file"))
                {                
                    if($file != "." && $file != "..")
                    {
                        $this->AddObsDirectory($Path . "/$file");
                        $this->AddRelDirectory($file);
                        
                        //  丮϶ ε  
                        if($file != "image" && $file != "images" && $file != "img" && $file != "PHOTO")
                            $this->LoadDirectory($Path ."/$file");
                    }       
                }                                 
            }  
            closedir($dir);
        }
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function LoadFile($Path)
    {        
        $Ret = array();
        if ($dir = @opendir($Path)) 
        {
            while (($file = readdir($dir)) !== false) 
            {                
                if(is_file($Path . "/$file"))
                {
                    $Ret[count($Ret)] = $file;                    
                }                                 
            }  
            closedir($dir);
        }
        return $Ret;
    }    
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function AddObsDirectory($Directory)
    {
        $this->m_ObsDirectory[count($this->m_ObsDirectory)] = $Directory;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function ObsDirectoryCount()
    {
        return count($this->m_ObsDirectory);
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function ObsDirectory($Index)
    {
        return $this->m_ObsDirectory[$Index];
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function AddRelDirectory($Directory)
    {
        $this->m_RelDirectory[count($this->m_RelDirectory)] = $Directory;
    }
    
    
    /* --------------------------------------------------
     * access : 
     *
     * -------------------------------------------------- */
    function RelDirectory($Index)
    {
        return $this->m_RelDirectory[$Index];
    }
}
?>